#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define N   1024

double A[N][N];
double B[N][N];
double C[N][N];

int main() {
    int i, j, k;

    printf("Initializing matrices...\n");

    // initialize A
    for (i = 0; i < N; i++) {
        for (j = 0; j < N; j++) {
            A[i][j] = i*j;
        }
    }

    memcpy(B, A, sizeof(A));
    memset(C, 0, sizeof(C));

    printf("Multiplying matrices...\n");

    #if VERSION == 0    // ijk scheme

    for (i=0; i<N; i++)
        for (j=0; j<N; j++)
            for (k=0; k<N; k++)
                C[i][j] += A[i][k] * B[k][j];

    #elif VERSION == 1  // kij scheme

    for (k=0; k<N; k++)
        for (i=0; i<N; i++)
            for (j=0; j<N; j++)
                C[i][j] += A[i][k] * B[k][j];

    #elif VERSION == 2 // jki scheme

    for (j=0; j<N; j++)
        for (k=0; k<N; k++)
            for (i=0; i<N; i++)
                C[i][j] += A[i][k] * B[k][j];

    #endif

    return 0;
}
